Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.ka2ddo.yaac.io
Class NonshareableBufferedInputStream

    java.lang.Object
      java.io.InputStream
          java.io.FilterInputStream
              org.ka2ddo.yaac.io.NonshareableBufferedInputStream

All Implemented Interfaces:
  java.io.Closeable

    public final class NonshareableBufferedInputStream

extends java.io.FilterInputStream

This class is a copy of java.io.BufferedInputStream, but without the synchronization, which restricts instances of this class to use in a single thread.

Field Summary

Fields inherited from class java.io.FilterInputStream
`in`

Constructor Summary
`NonshareableBufferedInputStream(java.io.InputStream in)` Creates a `BufferedInputStream` and saves its argument, the input stream `in`, for later use.
`NonshareableBufferedInputStream(java.io.InputStream in, byte[] buf)` Creates a new buffered output stream to write data to the specified underlying output stream with the specified buffer.
`NonshareableBufferedInputStream(java.io.InputStream in, int size)` Creates a `NonshareableBufferedInputStream` with the specified buffer size, and saves its argument, the input stream `in`, for later use.

Method Summary
`int` | `available()` Returns an estimate of the number of bytes that can be read (or skipped over) from this input stream without blocking by the next invocation of a method for this input stream.
`void` | `close()` Closes this input stream and releases any system resources associated with the stream.
`void` | `mark(int readlimit)` See the general contract of the `mark` method of `InputStream`.
`boolean` | `markSupported()` Tests if this input stream supports the `mark` and `reset` methods.
`int` | `read()` See the general contract of the `read` method of `InputStream`.
`int` | `read(byte[] b)` Reads up to `byte.length` bytes of data from this input stream into an array of bytes.
`int` | `read(byte[] b, int off, int len)` Reads bytes from this byte-input stream into the specified byte array, starting at the given offset.
`void` | `reset()` See the general contract of the `reset` method of `InputStream`.
`long` | `skip(long n)` See the general contract of the `skip` method of `InputStream`.

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Constructor Detail

### NonshareableBufferedInputStream

    public NonshareableBufferedInputStream(java.io.InputStream in)

  Creates a `BufferedInputStream` and saves its argument, the input stream `in`, for later use. An internal buffer array is created and stored in `buf`.

  Parameters:
    `in` - the underlying input stream.

### NonshareableBufferedInputStream

    public NonshareableBufferedInputStream(java.io.InputStream in,
                                           int size)

  Creates a `NonshareableBufferedInputStream` with the specified buffer size, and saves its argument, the input stream `in`, for later use. An internal buffer array of length `size` is created and stored in `buf`.

  Parameters:
    `in` - the underlying input stream.
    `size` - the buffer size.
  Throws:
    `java.lang.IllegalArgumentException` - if size <= 0.

### NonshareableBufferedInputStream

    public NonshareableBufferedInputStream(java.io.InputStream in,
                                           byte[] buf)

  Creates a new buffered output stream to write data to the specified underlying output stream with the specified buffer.

  Parameters:
    `in` - the underlying input stream.
    `buf` - the buffer to use
  Throws:
    `java.lang.IllegalArgumentException` - if buffer size == 0.

Method Detail

### read

    public int read()
             throws java.io.IOException

  See the general contract of the `read` method of `InputStream`.

  Overrides:
    `read` in class `java.io.FilterInputStream`
  Returns:
    the next byte of data, or `-1` if the end of the stream is reached.
  Throws:
    `java.io.IOException` - if this input stream has been closed by invoking its `close()` method, or an I/O error occurs.
  See Also:
    `FilterInputStream.in`

### read

    public int read(byte[] b)
             throws java.io.IOException

  Reads up to `byte.length` bytes of data from this input stream into an array of bytes. This method blocks until some input is available.

  This method simply performs the equivalent of `read(b, 0, b.length)` and returns the result.

  Overrides:
    `read` in class `java.io.FilterInputStream`
  Parameters:
    `b` - the buffer into which the data is read.
  Returns:
    the total number of bytes read into the buffer, or `-1` if there is no more data because the end of the stream has been reached.
  Throws:
    `java.io.IOException` - if an I/O error occurs.

### read

    public int read(byte[] b,
                    int off,
                    int len)
             throws java.io.IOException

  Reads bytes from this byte-input stream into the specified byte array, starting at the given offset.

  This method implements the general contract of the corresponding ``read`` method of the ``InputStream`` class. As an additional convenience, it attempts to read as many bytes as possible by repeatedly invoking the `read` method of the underlying stream. This iterated `read` continues until one of the following conditions becomes true:

  - The specified number of bytes have been read,
  - The `read` method of the underlying stream returns `-1`, indicating end-of-file, or
  - The `available` method of the underlying stream returns zero, indicating that further input requests would block.
  If the first `read` on the underlying stream returns `-1` to indicate end-of-file then this method returns `-1`. Otherwise this method returns the number of bytes actually read.

  Subclasses of this class are encouraged, but not required, to attempt to read as many bytes as possible in the same fashion.

  Overrides:
    `read` in class `java.io.FilterInputStream`
  Parameters:
    `b` - destination buffer.
    `off` - offset at which to start storing bytes.
    `len` - maximum number of bytes to read.
  Returns:
    the number of bytes read, or `-1` if the end of the stream has been reached.
  Throws:
    `java.io.IOException` - if this input stream has been closed by invoking its `close()` method, or an I/O error occurs.

### skip

    public long skip(long n)
              throws java.io.IOException

  See the general contract of the `skip` method of `InputStream`.

  Overrides:
    `skip` in class `java.io.FilterInputStream`
  Throws:
    `java.io.IOException` - if the stream does not support seek, or if this input stream has been closed by invoking its `close()` method, or an I/O error occurs.

### available

    public int available()
                  throws java.io.IOException

  Returns an estimate of the number of bytes that can be read (or skipped over) from this input stream without blocking by the next invocation of a method for this input stream. The next invocation might be the same thread or another thread. A single read or skip of this many bytes will not block, but may read or skip fewer bytes.

  This method returns the number of bytes remaining to be read in the buffer (`count - pos`), possibly refilling the buffer if it was empty at the time of this call. Specifically, it does _not_ try to return the total remaining bytes in the file.

  Overrides:
    `available` in class `java.io.FilterInputStream`
  Returns:
    an estimate of the number of bytes that can be read (or skipped over) from this input stream without blocking.
  Throws:
    `java.io.IOException` - if this input stream has been closed by invoking its `close()` method, or an I/O error occurs.

### mark

    public void mark(int readlimit)

  See the general contract of the `mark` method of `InputStream`.

  Overrides:
    `mark` in class `java.io.FilterInputStream`
  Parameters:
    `readlimit` - the maximum limit of bytes that can be read before the mark position becomes invalid.
  See Also:
    `reset()`

### reset

    public void reset()
               throws java.io.IOException

  See the general contract of the `reset` method of `InputStream`.

  If `markpos` is `-1` (no mark has been set or the mark has been invalidated), an `IOException` is thrown. Otherwise, `pos` is set equal to `markpos`.

  Overrides:
    `reset` in class `java.io.FilterInputStream`
  Throws:
    `java.io.IOException` - if this stream has not been marked or, if the mark has been invalidated, or the stream has been closed by invoking its `close()` method, or an I/O error occurs.
  See Also:
    `mark(int)`

### markSupported

    public boolean markSupported()

  Tests if this input stream supports the `mark` and `reset` methods. The `markSupported` method of `NonshareableBufferedInputStream` returns `false`.

  Overrides:
    `markSupported` in class `java.io.FilterInputStream`
  Returns:
    a `boolean` indicating if this stream type supports the `mark` and `reset` methods.
  See Also:
    `InputStream.mark(int)`, `InputStream.reset()`

### close

    public void close()
               throws java.io.IOException

  Closes this input stream and releases any system resources associated with the stream. Once the stream has been closed, further read(), available(), reset(), or skip() invocations will throw an IOException. Closing a previously closed stream has no effect.

  Specified by:
    `close` in interface `java.io.Closeable`
  Overrides:
    `close` in class `java.io.FilterInputStream`
  Throws:
    `java.io.IOException` - if an I/O error occurs.

Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD